//CRYSISHUD, Manufactured by Dlaor, if you're going to edit it: credit me, or I'll disintegrate your soul!

local soundconvar = CreateClientConVar( "crysishud_enablesounds", 1, false, false )
local smoothconvar = CreateClientConVar( "crysishud_enabletransitions", 1, false, false )

local crytx = surface.GetTextureID( "crysis_button" )
local crycircletx = surface.GetTextureID( "crysis_circle" )
local cryarrowtx = surface.GetTextureID( "crysis_arrow" )
local global_mul, global_mul_goal = 0, 0 //The global multiplier, if this is 0 the menu is hidden, 1 and it's fully visible, between 0 and 1 for transition
local cryx, cryy = ScrW() / 2, ScrH() / 2 //Changing this makes the menu appear in a different place
local selected, oldselected = 0, 0 //Which slot is selected?

local snd_o, snd_c, snd_s, snd_h, snd_e = Sound( "cry_open.wav" ), Sound( "cry_close.wav" ), Sound( "cry_select.wav" ), Sound( "cry_hover.wav" ), Sound( "cry_error.wav" )

local crydist = {} //Distance to center for every slot
for i = 1, 5 do
	crydist[i] = 0
end

local weapontab = {} //I love mah tables (don't touch this one)
weapontab["Crowbar"] = {}
weapontab["Crowbar"].number = "6" //This is the character in the HL2MPTypeDeath font
weapontab["Crowbar"].name = "weapon_crowbar" //This is the weapon class name to switch to
weapontab["GravityGun"] = {}
weapontab["GravityGun"].number = "9"
weapontab["GravityGun"].name = "weapon_physcannon"
weapontab["PhysicsGun"] = {}
weapontab["PhysicsGun"].number = "9"
weapontab["PhysicsGun"].name = "weapon_physgun"
weapontab["Pistol"] = {}
weapontab["Pistol"].number = "-"
weapontab["Pistol"].name = "weapon_pistol"
weapontab["Revolver"] = {}
weapontab["Revolver"].number = "."
weapontab["Revolver"].name = "weapon_357"
weapontab["SMG"] = {}
weapontab["SMG"].number = "/"
weapontab["SMG"].name = "weapon_smg1"
weapontab["AR2"] = {}
weapontab["AR2"].number = "2"
weapontab["AR2"].name = "weapon_ar2"
weapontab["Shotgun"] = {}
weapontab["Shotgun"].number = "0"
weapontab["Shotgun"].name = "weapon_shotgun"
weapontab["Crossbow"] = {}
weapontab["Crossbow"].number = "1"
weapontab["Crossbow"].name = "weapon_crossbow"
weapontab["Grenade"] = {}
weapontab["Grenade"].number = "4"
weapontab["Grenade"].name = "weapon_frag"
weapontab["RPG"] = {}
weapontab["RPG"].number = "3"
weapontab["RPG"].name = "weapon_rpg"
weapontab["Stunstick"] = {}
weapontab["Stunstick"].number = "!"
weapontab["Stunstick"].name = "weapon_stunstick"
weapontab["SLAM"] = {}
weapontab["SLAM"].number = "*"
weapontab["SLAM"].name = "weapon_slam"

local slots = {} //Standard slots, change these at will
slots[1] = weapontab["Crowbar"]
slots[2] = weapontab["PhysicsGun"]
slots[3] = weapontab["AR2"]
slots[4] = weapontab["Shotgun"]
slots[5] = weapontab["RPG"]

function MouseInCircle( x, y ) //Checks if the mouse is in the circle
	
	local centerdist = math.Dist( gui.MouseX(), gui.MouseY(), x, y )
	return ( centerdist > 32 and centerdist < 150 )
	
end

function CRYHUD() //Good luck figuring all this shit out
	
	if ( global_mul_goal != global_mul ) then
		global_mul = global_mul + ( global_mul_goal - global_mul ) * math.Clamp( FrameTimeExt() * 10, 0, 1 ) //I love mah math
	end 
	
	if ( global_mul == 0 ) then return end //Don't run if the menu ain't visible
	
	surface.SetTexture( crytx )
	surface.SetDrawColor( 255, 255, 255, 255 )
	surface.SetTextColor( 255, 255, 255, global_mul * 255 )
	surface.SetFont( "HL2MPTypeDeath" )

	local cryadd = 360/5
	local numb = 1
	local cursorang = math.fmod( math.atan2( gui.MouseY() - cryy, gui.MouseX() - cryx ), math.pi * 2 ) //This angle shit makes my head implode
	local cursorangd = math.deg( cursorang ) + 180
	
	if ( cursorangd >= 0 and cursorangd < cryadd ) then selected = 4
	elseif ( cursorangd >= cryadd and cursorangd < cryadd * 2 ) then selected = 3
	elseif ( cursorangd >= cryadd * 2 and cursorangd < cryadd * 3 ) then selected = 2
	elseif ( cursorangd >= cryadd * 3 and cursorangd < cryadd * 4 ) then selected = 1
	elseif ( cursorangd >= cryadd * 4 and cursorangd < cryadd * 5 ) then selected = 5
	end //Fucking hell this took like forever ever to figure out
	
	if ( !MouseInCircle( cryx, cryy ) ) then selected = 0 end //If the mouse isn't in the circle, don't light up any slot
	
	for i = 0 + cryadd / 2, 360 - cryadd / 2, cryadd do
		
		local crydistadd = 96
		local crygray = 200
		if ( numb == selected ) then //If the slot is selected, light it up and move it outside
			crydistadd = crydistadd * 1.3
			crygray = 255
		end
		
		crydist[numb] = crydist[numb] + ( crydistadd - crydist[numb] ) * math.Clamp( FrameTimeExt() * 20, 0, 1 )
		
		local cryaddx, cryaddy = math.sin( math.rad( i ) ) * crydist[numb] * global_mul, math.cos( math.rad( i ) ) * crydist[numb] * global_mul
		local crytxtw, crytxth = surface.GetTextSize( slots[numb].number )
		surface.SetDrawColor( crygray, crygray, crygray, global_mul * 200 )
		surface.DrawTexturedRectRotated( cryx + cryaddx, cryy + cryaddy, 100 * global_mul, 100 * global_mul, i - 180 )
		surface.SetTextPos( cryx + cryaddx - crytxtw / 2, cryy + cryaddy - crytxth / 2 + 10 )

		surface.DrawText( slots[numb].number ) //Draw the character
		
		numb = numb + 1
		
	end
	
	surface.SetTexture( crycircletx )
	surface.SetDrawColor( 255, 255, 255, global_mul * 255 )
	surface.DrawTexturedRectRotated( cryx, cryy, 128 * global_mul, 128 * global_mul, math.fmod( CurTime() * -20, 360 ) )
	
	surface.SetTexture( cryarrowtx )
	local arrowang = math.pi * 2 - cursorang + math.pi / 2
	local arrowdist = 47 * global_mul
	local arrowx, arrowy = math.sin( arrowang ) * arrowdist, math.cos( arrowang ) * arrowdist
	surface.DrawTexturedRectRotated( cryx + arrowx, cryy + arrowy, 128 / 3, 32 / 3, math.deg( arrowang ) + 180 )
	
	if ( selected != oldselected and selected != 0 ) then PlaySnd( snd_h ) oldselected = selected end
	

end

hook.Add( "HUDPaint", "CRYHUD", CRYHUD )

function EnableMenu( b )

	if ( ( b and global_mul_goal == 0 ) ) then PlaySnd( snd_o ) end
	gui.EnableScreenClicker( b )
	if ( b ) then global_mul_goal = 1 else global_mul_goal = 0 end
	
end

function ChangeSlots( ply, cmd, args )
	
	local fail = 0
	
	for u = 1, 5 do
		if ( args[u] ) then if ( !weapontab[args[u]] ) then fail = 9001 /*HURR*/ end slots[u] = weapontab[args[u]] else fail = fail + 0.2 end
	end
	
	if ( fail >= 1 ) then MsgN( "You're doing it wrong!" ) end
	
end
 
function ChangeSlotsAutoComplete( cmdname, args )

	local rettable = { "Crowbar", "GravityGun", "PhysicsGun", "Pistol", "Revolver", "SMG", "AR2", "Shotgun", "Crossbow", "Grenade", "RPG", "Stunstick", "SLAM" }
	for i = 1, #rettable do
		rettable[i] = cmdname .. args .. rettable[i]
	end
	return rettable
	
end

concommand.Add( "crysishud_slots", ChangeSlots, ChangeSlotsAutoComplete )

function CryOpenClose( ply, command, args )
	
	if ( command != "+crysishud" ) then
		if ( MouseInCircle( cryx, cryy ) ) then
			PlaySnd( snd_s )
			if ( slots[selected] ) then RunConsoleCommand( "use", slots[selected].name ) end //Select weapon
			if ( !HasWep( slots[selected].name ) ) then PlaySnd( snd_e ) end
		elseif ( global_mul_goal == 1 ) then PlaySnd( snd_c ) end
	end	
	
	EnableMenu( command == "+crysishud" ) //Enable menu if it's +crysishud, disable otherwise

end

concommand.Add( "+crysishud", CryOpenClose )
concommand.Add( "-crysishud", CryOpenClose )

function HasWep( wep )

	local weps = LocalPlayer():GetWeapons()
	
	for k, v in pairs( weps ) do
		weps[k] = v:GetClass()
	end
	
	-------- Double in pairs loop because the first one needs to process them all before we can use them --------
	
	local found = false
	
	for i = 1, #weps do
		if ( weps[i] == wep ) then found = true break end
	end
	
	return found
	
end

function PlaySnd( snd ) //Custom sound play function to refuse to play the sound if the sound convar isn't 1

	if ( soundconvar:GetBool() ) then surface.PlaySound( snd ) end
	
end

function FrameTimeExt() //Custom frame time function to disable the transitions if the smooth convar is 1 by just returning 1 instead of the frame time

	if ( smoothconvar:GetBool() ) then return FrameTime() else return 1 end
	
end
